#include <algorithm>
#include <map>
#include <cstdio>
#include <cstring>
using namespace std;
const int N=1e5+5;
int a[N];
int main()
{
    int T,n,q,op,p,v;
    scanf("%d",&T);
    map<int,int> M;
    while(T--)
    {
        M.clear();
        scanf("%d%d",&n,&q);
        for(int i=1; i<=n; i++)
            scanf("%d",a+i),M[a[i]]++;
        while(q--)
        {
            scanf("%d",&op);
            if(op==1)
            {
                scanf("%d%d",&p,&v);
                if((--M[a[p]])==0)
                    M.erase(a[p]);
                M[a[p]=v]++;
            }
            if(op==2)
            {
                M.erase(0);
                printf("%d\n",M.size());
            }
        }
    }
    return 0;
}
